library(stockassessment)
load("run/model.RData")
#load(choose.files)

#These numbers need to be changed to be applicable to ple7fg for each of the two versions of the assessment
F_MSY <- 0.147 #changed
F_MSY_lower <- 0.099 #changed
F_MSY_upper <- 0.230 # changed
Fpa <- 0.592 #as at Benchmark
Flim <- 1.275 #as Benchmark
Blim <- 1344 #Benchmark
Bpa <- 1882 #Benchmark
MSY_Btrigger <- 1882 #Benchmark

prev.TAC <- 1911 #TAC for intermediate year -2021
prev.advice <- 1911 #Advice for intermediate year 2021


#Options for forecast
rec.years <- 2019:2021
ave.years <- max(fit$data$years) + (-2:0)   #Last three years fro selectivity and mean weights
f_mean <- mean(tail(fbartable(fit)[,1], 3))  #F for intermediate year, average of last three years
land_frac <- colMeans(tail(fit$data$landFrac, 3)) #Average landings fractions for last three years


#########  forecast   ##########

FC<-list()
ac <- as.character

# 2022F=Fsq then Fmsy
set.seed(12345) #sets the starting number used to generate a sequence of random numbers - it ensures that you get the same result if you start with that same seed each time you run the same process
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,F_MSY,F_MSY), 
                               label="2022F=Fsq then Fmsy", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)
               
# 2022F=Fsq then Fmsy lower
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,F_MSY_lower,F_MSY_lower), 
                               label="2022F=Fsq then Fmsy lower", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)

# 2022F=Fsq then Fmsy upper
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,F_MSY_upper,F_MSY_upper), 
                               label="2022F=Fsq then Fmsy upper", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)


# 2022F=Fsq then zero
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,0,0), fval=c(NA,f_mean,NA,NA),
                               label="2022F=Fsq then 0", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)

# 2022F=Fsq then Fpa
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,Fpa,Fpa), 
                               label="2022F=Fsq then Fpa", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)


# 2022F=Fsq then Flim
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,Flim,Flim), 
                               label="2022F=Fsq then Flim", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)


# #F that will get us to Blim
# optim_B <- function(f2target, target, f_mean, F_MSY, B_yr,
#                     ave.years, rec.years){
#   set.seed(12345)
#   f1 <- forecast(fit, 
#                  fscale =   c(1,          NA,       NA, NA), 
#                  fval =     c(NA,         f_mean, f2target, F_MSY), 
#                  catchval = c(NA,         NA,       NA, NA),
#                  ave.years = ave.years, 
#                  rec.years = rec.years, savesim = TRUE)####
#   ssb <- attr(f1,"shorttab")["ssb", ac(B_yr)]
#   out <- 1E+3*(ssb - target)^2
#   return(out)
# }
# 
# f_val <- optimise(f = optim_B, interval = seq(from = 0, to = 3, by = 0.001), 
#                   target = Blim, f_mean=f_mean, F_MSY = F_MSY,
#                   B_yr = 2023, 
#                   ave.years = ave.years, 
#                   rec.years = rec.years)$minimum
# 
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale = c(1, NA, NA, 1), 
#                                fval = c(NA, f_mean, f_val, NA), 
#                                ave.years = ave.years, 
#                                rec.years = rec.years,
#                                label="Fsq, SSB(2023)=Blim", splitLD=TRUE, savesim = TRUE)
# 
# 
# #F that will get us to Bpa
# f_val <- optimise(f = optim_B, interval = seq(from = 0, to = 3, by = 0.001), 
#                   target = Bpa, f_mean = f_mean, F_MSY = F_MSY,
#                   B_yr = 2023, 
#                   ave.years = max(fit$data$years) + (-2:0), 
#                   rec.years = 2015:2019)$minimum
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale = c(1, NA, NA, 1), 
#                                fval = c(NA, f_mean, f_val, NA), 
#                                ave.years = max(fit$data$years) + (-2:0), 
#                                rec.years = 2015:2019,
#                                label="Fsq, SSB(2023)=Bpa", splitLD=TRUE, savesim = TRUE)
# 
# 
# #F that will get us to MSY Btrigger
# f_val <- optimise(f = optim_B, interval = seq(from = 0, to = 3, by = 0.001), 
#                   target = MSY_Btrigger, f_mean = f_mean, F_MSY = F_MSY,
#                   B_yr = 2023, 
#                   ave.years = max(fit$data$years) + (-2:0), 
#                   rec.years = 2015:2019)$minimum
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale = c(1, NA, NA, 1), 
#                                fval = c(NA, f_mean, f_val, NA), 
#                                ave.years = max(fit$data$years) + (-2:0), 
#                                rec.years = 2015:2019,
#                                label="Fsq, SSB(2023)=MSY Btrigger", splitLD=TRUE, savesim = TRUE)
# 
# 
# # SQ
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,f_mean,f_mean), 
#                                label="2022F=Fsq then Fsq", rec.years=2015:2019,
#                                ave.years = max(fit$data$years) + (-2:0),
#                                splitLD = TRUE, savesim = TRUE)
# 
# 
# 
# 
# # TAC #### Does not show the plot but save it!!!!!!
# 
# TAC <- 2846   #No TAC yet, use advice instead
# TAC_red <- TAC /  ((1-deaddisrate) + deaddisrate / 0.6)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,f_mean,NA,NA),
                               catchval=c(NA,NA,prev.TAC, prev.TAC),
                               label="2022F=Fsq then TAC", rec.years=rec.years,
                               ave.years = ave.years,
                               splitLD = TRUE, savesim = TRUE)
# 
# 
# #F that will get us to MSY Btrigger
# 
# B_target <- median(FC[[1]][[3]]$ssb    )  ##SSB at the start of advice year
# f_val <- optimise(f = optim_B, interval = seq(from = 0, to = 3, by = 0.001), 
#                   target = B_target, f_mean = f_mean, F_MSY = F_MSY,
#                   B_yr = 2023, 
#                   ave.years = max(fit$data$years) + (-2:0), 
#                   rec.years = 2015:2019)$minimum
# set.seed(12345)
# FC[[length(FC)+1]] <- forecast(fit, fscale = c(1, NA, NA, 1), 
#                                fval = c(NA, f_mean, f_val, NA), 
#                                ave.years = max(fit$data$years) + (-2:0), 
#                                rec.years = 2015:2019,
#                                label="Fsq, SSB(2023)=SSB(2022)", splitLD=TRUE, savesim = TRUE)
# 
# 

save(FC, file= "run/forecast.RData")



Table2 <- NULL
Table3 <- NULL
for (i in 1:length(FC))
{
#  windows()
#  plot(FC[[i]])
#  title(main=attributes(FC[[i]])$label, outer=F, cex.main=1)
 # savePlot(paste0(path_out,"Tables&Figures/Figures/", attributes(FC[[i]])$label, ".png"), type="png" )
  
  
  
  Table2 <- rbind(Table2, data.frame(Basis=attributes(FC[[i]])$label,
                                     Ftot=median(FC[[i]][[2]]$fbar),
                                     SSB = median(FC[[i]][[3]]$ssb),
                                     R1 =  median(FC[[i]][[2]]$rec),
                                     R2 =  median(FC[[i]][[3]]$rec),
                                     TotCatch=median(FC[[i]][[2]]$catch),
                                     Landings=median(FC[[i]][[2]]$land), 
                                     Discards=median(FC[[i]][[2]]$catch - FC[[i]][[2]]$land))
                                     
                                     
  ) 
  
  Table3 <- rbind(Table3, data.frame(Basis=attributes(FC[[i]])$label,
                                     TotCatch=median(FC[[i]][[3]]$catch),
                                     WCatch=median(FC[[i]][[3]]$land),
                                     UCatch =median(FC[[i]][[3]]$catch - FC[[i]][[3]]$land),
                                     Ftot=median(FC[[i]][[3]]$fbar),
                                     Fw=median(FC[[i]][[3]]$fbarL),
                                     Fu=median(FC[[i]][[3]]$fbar - FC[[i]][[3]]$fbarL),
                                     SSB = median(FC[[i]][[4]]$ssb    ),
                                     SSBpc =NA,
                                     TACpc=NA,
                                     Advicepc = NA))
  
}

Table2 #ccheck rows are all the same
Table3

Table3$SSBpc <- 100 * (Table3$SSB/Table2$SSB -1)
Table3$TACpc <- 100 * (Table3$TotCatch/prev.TAC - 1)
Table3$Advicepc <- 100 * (Table3$TotCatch/prev.advice - 1)
